/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2005  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 *********************************************************************/

#include "constants.h"

#ifdef USE_UI_GTKMM

#include "game_info.h"

#include "ui.h"
#include "translations.h"
#include "main_window.h"
#include "cards.h"

#include "widgets/stock_button.h"

#include "../../card/trick.h"
#include "../../player/ai/ai.h"
#include "../ui.wrap.h"
#include "../../utils/string.h"

#include <gtkmm/stock.h>
#include <gtkmm/label.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>
#include <gtkmm/treestore.h>
#include <gtkmm/alignment.h>
#include <gtkmm/frame.h>
#include <gtkmm/box.h>
#include <gtkmm/scrolledwindow.h>

namespace UI_GTKMM_NS {

  /**
   **
   ** Constructor
   **
   ** @param	parent	the parent widget
   **
   ** @return	-
   ** 
   ** @author	Diether Knof
   **
   ** @version	0.6.8
   **
   **/
  GameInfo::GameInfo(Base* const parent) :
    Base(parent),
    StickyDialog("Game info",
		 false, true),
    OS(),
    seed(NULL),
    gametype(NULL),
    soloplayer(NULL),
    player_info_model(),
    player_info_list(NULL),
    player_info_treeview(NULL),
    player_info_rows(),
    team_info_model(),
    team_info_list(NULL),
    team_info_treeview(NULL),
    team_info_rows(),
    tricks_model(),
    tricks_store(NULL),
    tricks_treeview(NULL),
    tricks_rows(),
    ai_test_rows()
  {
#ifndef RELEASE
    dynamic_cast<UI_Wrap*>(::ui)->append(this);

    this->init();
#endif

    return ;
  } // GameInfo::GameInfo(Base* parent)

  /**
   **
   ** Destruktor
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** @author	Diether Knof
   **
   ** @version	0.6.8
   **
   **/
  GameInfo::~GameInfo()
  {
    dynamic_cast<UI_Wrap*>(::ui)->remove(this);

    return ;
  } // GameInfo::~GameInfo()

  /**
   **
   ** the game is opened
   **
   ** @param	game	game that is opened
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::game_open(Game const& game)
    {
      this->OS::game_open(game);

      this->tricks_rows.clear();
      this->tricks_store->clear();

      while (!this->ai_test_rows.empty())
	this->ai_test_rows.pop();

      return ;
    } // void GameInfo::game_open(Game const& game)

  /**
   **
   ** the game is redistributed
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::game_redistribute()
    {
      return ;
    } // void GameInfo::game_redistribute()

  /**
   **
   ** the game is started
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   ** @todo	all
   **
   **/
  void
    GameInfo::game_start()
    {
      this->update_info();

      return ;
    } // void GameInfo::game_start()

  /**
   **
   ** a new trick has opened
   **
   ** @param	trick	new trick
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::trick_open(::Trick const& trick)
    { 
      this->OS::trick_open(trick);

      if (!this->tricks_rows.empty())
	this->tricks_treeview->collapse_row(this->tricks_store->get_path(this->tricks_rows.back()));
      this->tricks_rows.push_back(*this->tricks_store->append());
      this->tricks_rows.back()[this->tricks_model.trickno]
	= DK::Utils::String::to_string(trick.no());

      return ;
    } // void GameInfo::trick_open(Trick trick)

  /**
   **
   ** 'player' has played 'card'
   **
   ** @param	card	the played card
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::card_played(HandCard const& card)
    { 
      Player const& player = card.player();

      Gtk::TreeModel::Row row;
      if (this->ai_test_rows.empty())
	row = *this->tricks_store->append(this->tricks_rows.back().children());
      else {
	row = this->ai_test_rows.top();
	this->tricks_treeview->collapse_row(this->tricks_store->get_path(row));
	this->ai_test_rows.pop();
	while (!this->ai_test_rows.empty())
	  this->ai_test_rows.pop();
      }
      this->tricks_treeview->expand_row(this->tricks_store->get_path(row.parent()), false);
      row[this->tricks_model.playerno]
	= DK::Utils::String::to_string(player.no());
      // ToDo: translation in game
      row[this->tricks_model.card]
	= Glib::locale_to_utf8(::translator(::name(card)).translation());
      // ToDo: translation in game
      if (dynamic_cast<Ai const*>(&player)) {
	if (dynamic_cast<Ai const&>(player).lastHeuristic_
	    == Aiconfig::CHOOSE_BEST_CARD)
	  row[this->tricks_model.heuristic]
	    = Glib::locale_to_utf8(::translator(::name(dynamic_cast<Ai const&>(player).aitype())).translation());
	else
	  row[this->tricks_model.heuristic]
	    = Glib::locale_to_utf8(::translator(::name(dynamic_cast<Ai const&>(player).lastHeuristic_)).translation());
      }

      this->update_info();

      return ;
    } // void GameInfo::card_played(HandCard card)

  /**
   **
   ** the ai tests the card 'card'
   **
   ** @param	card		the card that is tested
   ** @param	playerno	number of the player who plays the card
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   ** @todo	translate card automatic
   **
   **/
  void
    GameInfo::ai_test_card(Card const& card, unsigned const playerno)
    {
      if (this->ai_test_rows.empty()) {
	this->ai_test_rows.push(*this->tricks_store->append(this->tricks_rows.back().children()));
	this->ai_test_rows.top()[this->tricks_model.heuristic]
	  = Glib::locale_to_utf8(::translator(::name(dynamic_cast<Ai const&>(this->ui->game().player_current()).aitype())).translation());
      }
      this->ai_test_rows.push(*this->tricks_store->append(this->ai_test_rows.top().children()));
      if (this->ai_test_rows.size() == 2)
	this->tricks_treeview->expand_to_path(this->tricks_store->get_path(this->ai_test_rows.top().parent()));
      this->ai_test_rows.top()[this->tricks_model.card]
	= Glib::locale_to_utf8(::translator(card).translation());
      this->ai_test_rows.top()[this->tricks_model.playerno]
	= DK::Utils::String::to_string(playerno);
      return ;
    } // void GameInfo::ai_test_card(Card card, unsigned playerno)

  /**
   **
   ** the ai has calculated a weighting for the tested card
   **
   ** @param	weighting	the weighting for the tested card
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::ai_card_weighting(int const weighting)
    {
      while (this->ai_test_rows.top()[this->tricks_model.isvirtual])
	this->ai_test_rows.pop();

      if ( (weighting == INT_MIN)
	   || (weighting == INT_MAX) )
	this->ai_test_rows.top()[this->tricks_model.heuristic]
	  = "-";
      else
	this->ai_test_rows.top()[this->tricks_model.heuristic]
	  = DK::Utils::String::to_string(weighting);

      this->ai_test_rows.top()[this->tricks_model.isvirtual]
	= false;

      this->tricks_treeview->collapse_row(this->tricks_store->get_path(this->ai_test_rows.top()));
      this->ai_test_rows.pop();

      return ;
    } // void GameInfo::ai_card_weighting(int weighting)

  /**
   **
   ** virtual game: card is played
   **
   ** @param	card	the card that is played
   **
   ** @return	-
   ** 
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   ** @todo	translate card automatic
   **
   **/
  void
    GameInfo::virtual_card_played(HandCard const& card)
    {
      ::Player const& player = card.player();

      this->ai_test_rows.push(*this->tricks_store->append(this->ai_test_rows.top().children()));
      Gtk::TreeModel::Row row = this->ai_test_rows.top();

      row[this->tricks_model.card]
	= Glib::locale_to_utf8(::translator(card).translation());
      row[this->tricks_model.playerno]
	= DK::Utils::String::to_string(player.no());
      if (dynamic_cast<Ai const*>(&player)) {
	if (dynamic_cast<Ai const&>(player).lastHeuristic_
	    == Aiconfig::CHOOSE_BEST_CARD)
	  row[this->tricks_model.heuristic]
	    = Glib::locale_to_utf8(::translator(::name(dynamic_cast<Ai const&>(player).aitype())).translation());
	else
	  row[this->tricks_model.heuristic]
	    = Glib::locale_to_utf8(::translator(::name(dynamic_cast<Ai const&>(player).lastHeuristic_)).translation());
      }
      row[this->tricks_model.isvirtual]
	= true;

      return ;
    } // void GameInfo::virtual_card_played(HandCard card)

  /**
   **
   ** the announcement 'announcement' has been made by player 'player'
   **
   ** @param	announcement	the announcement
   ** @param	player		the player, who has made the announcement
   **
   ** @return	-
   **
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::announcement_made(Announcement const& announcement,
				Player const& player)
    {
      this->update_info();

      return ;
    } // void GameInfo::announcement_made(Announcement announcement, Player player)

  /**
   **
   ** the player has swines
   **
   ** @param	player		the player with the swines
   **
   ** @return	-
   **
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::swines_announced(Player const& player)
    {
      this->update_info();

      return ;
    } // void GameInfo::swines_announced(Player player)

  /**
   **
   ** the player has hyperswines
   **
   ** @param	player		the player with the swines
   **
   ** @return	-
   **
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::hyperswines_announced(Player const& player)
    {
      this->update_info();

      return ;
    } // void GameInfo::hyperswines_announced(Player player)

  /**
   **
   ** marriage: Information of the new team
   **
   ** @param	bridegroom	the player with the marriage
   ** @param	bride		the bride
   **
   ** @return	-
   **
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::marriage(Player const& bridegroom, Player const& bride)
    {
      this->update_info();

      return ;
    } // void GameInfo::marriage(Player bridegroom, Player bride)

  /**
   **
   ** genscher: Information of the new team
   **
   ** @param	player	genscher player
   ** @param	partner	partner of the gensher player
   **
   ** @return	-
   **
   ** @version	0.6.8
   **
   ** @author	Diether Knof
   **
   **/
  void
    GameInfo::genscher(Player const& genscher, Player const& partner)
    {
      this->update_info();

      return ;
    } // void GameInfo::genscher(Player genscher, Player partner)

  /**
   **
   ** create all subelements
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** @author	Diether Knof
   **
   ** @version	0.6.8
   **
   **/
  void
    GameInfo::init()
    {
      this->ui->translations->add(*this, 
				  ::translator("Game information"));

      this->set_icon(this->ui->main_window->icon);

      { // action area
	Gtk::StockButton* close_button
	  = Gtk::manage(new Gtk::StockButton(Gtk::Stock::CLOSE, "close"));
	this->ui->translations->add(*close_button,
				    ::translator("close"));
	this->add_action_widget(*close_button, Gtk::RESPONSE_CLOSE);

	close_button->grab_default();

	close_button->signal_clicked().connect(SigC::slot(*this, &Gtk::Widget::hide));
      } // action area

      { // content
	Gtk::Box* content_box = Gtk::manage(new Gtk::HBox(false, 2 em));
	this->get_vbox()->add(*content_box);

	Gtk::Box* left_box = Gtk::manage(new Gtk::VBox(false, 1 ex));
	content_box->pack_start(*left_box, false, false);
	{ // game info
	  Gtk::Box* box = Gtk::manage(new Gtk::VBox(true, 1 ex));
	  box->set_border_width(1 em);

	  { // seed
	    Gtk::Box* box2 = Gtk::manage(new Gtk::HBox(false, 0));
	    Gtk::Label* label = Gtk::manage(new Gtk::Label("Seed: "));
	    this->ui->translations->add(*label,
					::translator("game seed") + ": ");
	    box2->pack_start(*label, false, false);
	    this->seed = Gtk::manage(new Gtk::Label(""));
	    box2->pack_start(*this->seed, false, false);

	    box->add(*box2);
	  } // seed
	  { // game type
	    Gtk::Box* box2 = Gtk::manage(new Gtk::HBox(false, 0));
	    Gtk::Label* label = Gtk::manage(new Gtk::Label("gametype: "));
	    this->ui->translations->add(*label,
					::translator("gametype") + ": ");
	    box2->pack_start(*label, false, false);
	    this->gametype = Gtk::manage(new Gtk::Label(""));
	    box2->pack_start(*this->gametype, false, false);

	    box->add(*box2);
	  } // game type
	  { // soloplayer
	    Gtk::Box* box2 = Gtk::manage(new Gtk::HBox(false, 0));
	    Gtk::Label* label = Gtk::manage(new Gtk::Label("soloplayer: "));
	    this->ui->translations->add(*label,
					::translator("soloplayer") + ": ");
	    box2->pack_start(*label, false, false);
	    this->soloplayer = Gtk::manage(new Gtk::Label(""));
	    box2->pack_start(*this->soloplayer, false, false);

	    box->add(*box2);
	  } // seed

	  Gtk::Frame* frame = Gtk::manage(new Gtk::Frame("Game info"));
	  this->ui->translations->add(*dynamic_cast<Gtk::Label*>(frame->get_label_widget()),
				      ::translator("Game info"));
	  frame->add(*box);
	  frame->set_border_width(1 em);
	  Gtk::Alignment* alignment
	    = Gtk::manage(new Gtk::Alignment(Gtk::ALIGN_CENTER,
					     Gtk::ALIGN_CENTER,
					     0, 0));
	  alignment->add(*frame);
	  left_box->pack_start(*alignment, false, true);
	} // game info

	{ // player_info
	  this->player_info_list
	    = Gtk::ListStore::create(this->player_info_model);
	  this->player_info_treeview
	    = Gtk::manage(new Gtk::TreeView(this->player_info_list));
	  this->player_info_treeview->get_selection()->set_mode(Gtk::SELECTION_NONE);

	  unsigned column = 0;
	  this->player_info_treeview->append_column("Name",
						    this->player_info_model.name);
	  column += 1;
	  this->player_info_treeview->append_column("Team",
						    this->player_info_model.team);
	  this->player_info_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;
	  this->player_info_treeview->append_column("Swines",
						    this->player_info_model.swines);
	  this->player_info_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;
	  this->player_info_treeview->append_column("Announcement",
						    this->player_info_model.announcement);
	  this->player_info_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;
	  this->player_info_treeview->append_column("Points",
						    this->player_info_model.points);
	  this->player_info_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;
	  this->player_info_treeview->append_column("Tricks",
						    this->player_info_model.tricks);
	  this->player_info_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;

	  for (unsigned p = 0;
	       p < ::party.rule()(Rule::NUMBER_OF_PLAYERS_IN_GAME);
	       ++p) {
	    this->player_info_rows.push_back(*this->player_info_list->append());
	    this->player_info_rows.back()[this->player_info_model.name]
	      = ::party.player(p).name();
	  }

	  Gtk::Alignment* a = Gtk::manage(new Gtk::Alignment);
	  a->set_border_width(1 em);
	  a->add(*this->player_info_treeview);
	  Gtk::Frame* frame = Gtk::manage(new Gtk::Frame("Player info"));
	  this->ui->translations->add(*dynamic_cast<Gtk::Label*>(frame->get_label_widget()),
				      ::translator("Player info"));
	  frame->add(*a);
	  frame->set_border_width(1 em);
	  Gtk::Alignment* alignment
	    = Gtk::manage(new Gtk::Alignment(Gtk::ALIGN_CENTER,
					     Gtk::ALIGN_CENTER,
					     0, 0));
	  alignment->add(*frame);
	  left_box->pack_start(*alignment, false, true);
	} // player_info

	{ // team_info
	  this->team_info_list
	    = Gtk::ListStore::create(this->team_info_model);
	  this->team_info_treeview
	    = Gtk::manage(new Gtk::TreeView(this->team_info_list));
	  this->team_info_treeview->get_selection()->set_mode(Gtk::SELECTION_NONE);

	  unsigned column = 0;
	  this->team_info_treeview->append_column("Name",
						  this->team_info_model.name);
	  column += 1;
	  for (unsigned p = 0;
	       p < this->team_info_model.known_team.size();
	       ++p) {
	    this->team_info_treeview->append_column(Glib::locale_to_utf8(::party.player(p).name()),
						    this->team_info_model.known_team[p]);
	    this->team_info_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	    column += 1;
	  }

	  // real team
	  this->team_info_rows.push_back(*this->team_info_list->append());
	  // teaminfo of the game
	  this->team_info_rows.push_back(*this->team_info_list->append());
	  for (unsigned p = 0;
	       p < this->team_info_model.known_team.size();
	       ++p) {
	    this->team_info_rows.push_back(*this->team_info_list->append());
	    this->team_info_rows.back()[this->team_info_model.name]
	      = ::party.player(p).name();
	  } // for (p)

	  Gtk::Alignment* a = Gtk::manage(new Gtk::Alignment);
	  a->set_border_width(1 em);
	  a->add(*this->team_info_treeview);
	  Gtk::Frame* frame = Gtk::manage(new Gtk::Frame("Team info"));
	  this->ui->translations->add(*dynamic_cast<Gtk::Label*>(frame->get_label_widget()),
				      ::translator("Team info"));
	  frame->add(*a);
	  frame->set_border_width(1 em);
	  Gtk::Alignment* alignment
	    = Gtk::manage(new Gtk::Alignment(Gtk::ALIGN_CENTER,
					     Gtk::ALIGN_CENTER,
					     0, 0));
	  alignment->add(*frame);
	  left_box->pack_start(*alignment, false, true);
	} // team_info

	{ // tricks
	  this->tricks_store = Gtk::TreeStore::create(this->tricks_model);
	  this->tricks_treeview
	    = Gtk::manage(new Gtk::TreeView(this->tricks_store));
	  this->tricks_treeview->get_selection()->set_mode(Gtk::SELECTION_MULTIPLE);
	  this->tricks_treeview->set_rules_hint(true);

	  unsigned column = 0;
	  this->tricks_treeview->append_column("Card",
					       this->tricks_model.card);
	  column += 1;
	  this->tricks_treeview->append_column("Player",
					       this->tricks_model.playerno);
	  this->tricks_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;
	  this->tricks_treeview->append_column("Trick",
					       this->tricks_model.trickno);
	  this->tricks_treeview->get_column_cell_renderer(column)->property_xalign() = 0.5;
	  column += 1;
	  this->tricks_treeview->append_column("heuristic",
					       this->tricks_model.heuristic);
	  column += 1;

	  Gtk::ScrolledWindow* scrolled_window
	    = Gtk::manage(new Gtk::ScrolledWindow);
	  scrolled_window->set_policy(Gtk::POLICY_AUTOMATIC,
				      Gtk::POLICY_AUTOMATIC);
	  scrolled_window->add(*this->tricks_treeview);
	  scrolled_window->set_hadjustment(this->tricks_treeview->property_hadjustment());
	  scrolled_window->set_vadjustment(this->tricks_treeview->property_vadjustment());

	  Gtk::Alignment* a = Gtk::manage(new Gtk::Alignment);
	  a->set_border_width(1 em);
	  a->add(*scrolled_window);
	  Gtk::Frame* frame = Gtk::manage(new Gtk::Frame("Tricks"));
	  this->ui->translations->add(*dynamic_cast<Gtk::Label*>(frame->get_label_widget()),
				      ::translator("Tricks"));
	  frame->add(*a);
	  frame->set_border_width(1 em);

	  content_box->pack_end(*frame, true, true);
	} // tricks
      } // content

      this->show_all_children();

      this->realize();

      this->language_update();

      return ;
    } // void GameInfo::init()

  /**
   **
   ** updates the information for the players
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** @author	Diether Knof
   **
   ** @version	0.6.8
   **
   **/
  void
    GameInfo::update_info()
    {
      if (!(::game_status & GAMESTATUS::GAME))
	return ;

      Game const& game = this->ui->game();

      this->seed->set_label(DK::Utils::String::to_string(game.seed()));
      this->gametype->set_label(Glib::locale_to_utf8(::translator(game.type()).translation()));
      if (game.exists_soloplayer())
	this->soloplayer->set_label(Glib::locale_to_utf8(game.soloplayer().name()));
      else
	this->soloplayer->set_label("-");

      for (unsigned p = 0; p < game.playerno(); ++p) {
	::Player const& player = game.player(p);

	{ // player info
	  Gtk::TreeModel::Row& row = this->player_info_rows[p];

	  row[this->player_info_model.team]
	    = Glib::locale_to_utf8(::translator(player.team()).translation());
	  row[this->player_info_model.swines]
	    = (player.swines_has() ? "S" : "");
	  if (player.hyperswines_has())
	    row[this->player_info_model.swines]
	      = row[this->player_info_model.swines] + "H";

	  row[this->player_info_model.announcement]
	    = ( (player.announcement() == ANNOUNCEMENT::NOANNOUNCEMENT)
		? Glib::locale_to_utf8("")
		: Glib::locale_to_utf8(::translator(player.announcement()).translation())
	      );
	  row[this->player_info_model.points]
	    = player.points_in_trickpile();
	  row[this->player_info_model.tricks]
	    = player.number_of_tricks();

	} // player info
	{ // team info
	  this->team_info_rows[0][this->team_info_model.known_team[p]]
	    = Glib::locale_to_utf8(::translator(::short_name(player.team())).translation());
	  this->team_info_rows[1][this->team_info_model.known_team[p]]
	    = Glib::locale_to_utf8(::translator(::short_name(player.game().teaminfo(player))).translation());

	  for (unsigned q = 0; q < game.playerno(); ++q) {
	    Player const& player2 = player.game().player(q);
	    this->team_info_rows[2 + q][this->team_info_model.known_team[p]]
	      = Glib::locale_to_utf8(::translator(::short_name(player2.teaminfo(player))).translation());
	  } // for (q)
	} // team info
      } // for (p)

      return ;
    } // void GameInfo::update_info()

  /**
   **
   ** the name of 'player' has changed
   **
   ** @param	player	player whose name has changed
   **
   ** @return	-
   ** 
   ** @author	Diether Knof
   **
   ** @version	0.6.8
   **
   **/
  void
    GameInfo::name_changed(Player const& player)
    {
      if (!this->is_realized())
	return;

      if (!(::game_status & GAMESTATUS::GAME))
	return ;

      this->team_info_treeview->get_column(1 + player.no())->set_title(Glib::locale_to_utf8(player.name())); 

      this->player_info_rows[player.no()][this->player_info_model.name]
	= Glib::locale_to_utf8(player.name());

      this->team_info_rows[2 + player.no()][this->team_info_model.name]
	= Glib::locale_to_utf8(player.name());

      return ;
    } // void GameInfo::name_changed(Player const& player)

  /**
   **
   ** updates the translations
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** @author	Diether Knof
   **
   ** @version	0.6.8
   **
   **/
  void
    GameInfo::language_update()
    {
      if (!this->is_realized())
	return;

      { // player info
	unsigned column = 0;
	this->player_info_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("Name").translation()));
	column += 1;
	this->player_info_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("Team").translation()));
	column += 1;
	this->player_info_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("Swines").translation()));
	column += 1;
	this->player_info_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("Announcement").translation()));
	column += 1;
	this->player_info_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("Points").translation()));
	column += 1;
	this->player_info_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("Tricks").translation()));
	column += 1;
      } // player info

      { // team info
	this->team_info_rows[0][this->team_info_model.name]
	  = Glib::locale_to_utf8(::translator("team").translation());
	this->team_info_rows[1][this->team_info_model.name]
	  = Glib::locale_to_utf8(::translator("game").translation());
      } // team info

      { // tricks
	unsigned column = 0;
	this->tricks_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("card").translation()));
	column += 1;
	this->tricks_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("player").translation()));
	column += 1;
	this->tricks_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("trick").translation()));
	column += 1;
	this->tricks_treeview->get_column(column)->set_title(Glib::locale_to_utf8(::translator("heuristic").translation()));
	column += 1;
      } // tricks

      this->update_info();

      return ;
    } // void GameInfo::language_update()

} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
